#include <app/Application.h>
#include <storage/Path.h>
#include <storage/File.h>
#include <storage/FindDirectory.h>

#include "ShareWindow.h"

#define BESHARE_SETTINGS_FILE_NAME "beshare_settings"   

int main(int, char **)
{
   BApplication app("application/x-vnd.Sugoi-BeShare");

   // Attempt to load settings...
   BMessage settingsMsg;
   BPath sPath;
   if (find_directory(B_USER_SETTINGS_DIRECTORY, &sPath) == B_NO_ERROR)
   {
      sPath.Append(BESHARE_SETTINGS_FILE_NAME);
      BFile settingsFile(sPath.Path(), B_READ_ONLY);
      if (settingsFile.InitCheck() == B_NO_ERROR) (void) settingsMsg.Unflatten(&settingsFile);
   }

   (new ShareWindow(settingsMsg))->Show();
   app.Run();

   // Attempt to save settings...
   if (find_directory(B_USER_SETTINGS_DIRECTORY, &sPath) == B_NO_ERROR)
   {
      sPath.Append(BESHARE_SETTINGS_FILE_NAME);
      BFile settingsFile(sPath.Path(), B_WRITE_ONLY|B_CREATE_FILE|B_ERASE_FILE);
      if (settingsFile.InitCheck() == B_NO_ERROR) (void) settingsMsg.Flatten(&settingsFile);
   }

   return 0;
}
