//    Peek, An Image Viewing Program for BeOS
//    Copyright (C) 2000 Durand Miller
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, version 2.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//


// FILE WINDOW OPTIONS

#include "FileOptions.h"

FileOptions::FileOptions(BRect r,char*name):
 BView(r,name,B_FOLLOW_ALL_SIDES,0) 
{
 BRect *box = new BRect(15,15,430,150); 

 BBox *tempBox = new BBox(*box,"slideBox");
 tempBox->SetLabel("General Options");

 box->Set(10,30,400,0);
 fileRunFile = new BCheckBox(*box,"fileRunFile",
                    "Double-clicking on a non-image file opens that file",
                    new BMessage(FILE_RUN_FILE));
 tempBox->AddChild(fileRunFile);

 box->Set(10,50,400,0);
 fileDeleteAll= new BCheckBox(*box,"fileDeleteAll",
                    "Allow deleting of non-image files from Peek",
                    new BMessage(FILE_DELETE_ALL));
 tempBox->AddChild(fileDeleteAll);

 box->Set(10,70,400,0);
 fileChangeOnDesktopLoad = new BCheckBox(*box,"fileChangeOnDesktopLoad",
                    "Change directory when loading the desktop image",
                    new BMessage(FILE_CHANGE_ON_DESKTOP_LOAD));
 tempBox->AddChild(fileChangeOnDesktopLoad);

 box->Set(10,90,400,0);
 fileOpenCompact = new BCheckBox(*box,"fileOpenCompact",
                    "Loading via Tracker (ie double-clicked an image file), starts in 'compact' mode.",
                    new BMessage(FILE_OPEN_COMPACT));
 tempBox->AddChild(fileOpenCompact);


 AddChild(tempBox);
 delete box;
}

void FileOptions::AttachedToWindow() {
 SetViewColor(Parent()->ViewColor());
 BView::AttachedToWindow();
}

void FileOptions::Change(uint32 a) {
 if (a==FILE_RUN_FILE) fileRunFile->SetValue(B_CONTROL_ON);
 if (a==FILE_DELETE_ALL) fileDeleteAll->SetValue(B_CONTROL_ON);
 if (a==FILE_CHANGE_ON_DESKTOP_LOAD) fileChangeOnDesktopLoad->SetValue(B_CONTROL_ON);
 if (a==FILE_OPEN_COMPACT) fileOpenCompact->SetValue(B_CONTROL_ON);
}


// FILES WINDOW OPTIONS
