//    Peek, An Image Viewing Program for BeOS
//    Copyright (C) 2000 Durand Miller
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, version 2.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//


// MOUSE WINDOW OPTIONS

#include "MouseOptions.h"

MouseOptions::MouseOptions(BRect r,char*name):
 BView(r,name,B_FOLLOW_ALL_SIDES,0) 
{
 BRect *box = new BRect(15,15,325,165); 

 BBox *tempBox = new BBox(*box,"mapping");
 tempBox->SetLabel("Mapping");

 // left mouse
 box->Set(10,20,100,40);
 tempBox->AddChild(new BStringView(*box,"mouseLeft","Left Button:"));

 box->Set(15,50,100,70);
 mouseleftclip = new BCheckBox(*box,"mouseleftclip","Clipping",new BMessage(MOUSE_LEFT_CLIP));
 tempBox->AddChild(mouseleftclip);

 box->Set(15,70,100,70);
 mouseleftscroll = new BCheckBox(*box,"mouseleftscroll","Scrolling",new BMessage(MOUSE_LEFT_SCROLL));
 tempBox->AddChild(mouseleftscroll);

 box->Set(15,90,100,70);
 mouseleftdrag = new BCheckBox(*box,"mouseleftdrag","Dragging",new BMessage(MOUSE_LEFT_DRAG));
 tempBox->AddChild(mouseleftdrag);

 box->Set(15,110,100,70);
 mouseleftmenu = new BCheckBox(*box,"mouseleftmenu","Popup Menu",new BMessage(MOUSE_LEFT_MENU));
 tempBox->AddChild(mouseleftmenu);


 // right mouse
 box->Set(110,20,200,40);
 tempBox->AddChild(new BStringView(*box,"mouseRight","Right Button:"));

 box->Set(115,50,200,70);
 mouserightclip = new BCheckBox(*box,"mouserightclip","Clipping",new BMessage(MOUSE_RIGHT_CLIP));
 tempBox->AddChild(mouserightclip);

 box->Set(115,70,200,70);
 mouserightscroll = new BCheckBox(*box,"mouserightscroll","Scrolling",new BMessage(MOUSE_RIGHT_SCROLL));
 tempBox->AddChild(mouserightscroll);

 box->Set(115,90,200,70);
 mouserightdrag = new BCheckBox(*box,"mouserightdrag","Dragging",new BMessage(MOUSE_RIGHT_DRAG));
 tempBox->AddChild(mouserightdrag);

 box->Set(115,110,200,70);
 mouserightmenu = new BCheckBox(*box,"mouserightmenu","Popup Menu",new BMessage(MOUSE_RIGHT_MENU));
 tempBox->AddChild(mouserightmenu);


 // middle mouse
 box->Set(210,20,300,40);
 tempBox->AddChild(new BStringView(*box,"mouseMiddle","Middle Button:"));

 box->Set(215,50,300,70);
 mousemiddleclip = new BCheckBox(*box,"mousemiddleclip","Clipping",new BMessage(MOUSE_MIDDLE_CLIP));
 tempBox->AddChild(mousemiddleclip);

 box->Set(215,70,300,70);
 mousemiddlescroll = new BCheckBox(*box,"mousemiddlescroll","Scrolling",new BMessage(MOUSE_MIDDLE_SCROLL));
 tempBox->AddChild(mousemiddlescroll);

 box->Set(215,90,300,70);
 mousemiddledrag = new BCheckBox(*box,"mousemiddledrag","Dragging",new BMessage(MOUSE_MIDDLE_DRAG));
 tempBox->AddChild(mousemiddledrag);

 box->Set(215,110,300,70);
 mousemiddlemenu = new BCheckBox(*box,"mousemiddlemenu","Popup Menu",new BMessage(MOUSE_MIDDLE_MENU));
 tempBox->AddChild(mousemiddlemenu);

 AddChild(tempBox);



// Drag mode box
 box->Set(335,15,435,165); 

  tempBox = new BBox(*box,"dragmode");
  tempBox->SetLabel("Drag Mode");


   box->Set(10,30,60,50);
   mousedragblend = new BCheckBox(*box,"mousedragblend","Blend",new BMessage(MOUSE_DRAG_BLEND));
   tempBox->AddChild(mousedragblend);
   box->Set(10,50,60,50);
   mousedragcopy = new BCheckBox(*box,"mousedragcopy","Copy",new BMessage(MOUSE_DRAG_COPY));
   tempBox->AddChild(mousedragcopy);
   box->Set(10,70,60,50);
   mousedraginvert = new BCheckBox(*box,"mousedraginvert","Invert",new BMessage(MOUSE_DRAG_INVERT));
   tempBox->AddChild(mousedraginvert);
   box->Set(10,90,60,50);
   mousedragicon = new BCheckBox(*box,"mousedragicon","Icon",new BMessage(MOUSE_DRAG_ICON));
   tempBox->AddChild(mousedragicon);

 box->Set(10,280,500,10);
 mousefilechange = new BCheckBox(*box,"mousefilechange",
                                "When a file is dropped onto Peek, change the directory as well.",
                                new BMessage(MOUSE_FILE_CHANGE));
 AddChild(mousefilechange);

 box->Set(10,300,500,10);
 mousefiledrop = new BCheckBox(*box,"mousefiledrop",
                                "Use simple drag & drop as opposed to negotiated drag & drop (see help)",
                                new BMessage(MOUSE_FILE_DROP));
 AddChild(mousefiledrop);


 AddChild(tempBox);

 delete box;
}

void MouseOptions::Change(uint32 a) {
 if ( a == MOUSE_LEFT_CLIP ) {   
   mouseleftclip->SetValue(B_CONTROL_ON);
   mouseleftdrag->SetValue(B_CONTROL_OFF);
   mouseleftscroll->SetValue(B_CONTROL_OFF);
   mouseleftmenu->SetValue(B_CONTROL_OFF);
 }
 if ( a == MOUSE_LEFT_DRAG ) {
   mouseleftclip->SetValue(B_CONTROL_OFF);
   mouseleftdrag->SetValue(B_CONTROL_ON);
   mouseleftscroll->SetValue(B_CONTROL_OFF);
   mouseleftmenu->SetValue(B_CONTROL_OFF);
 }
 if ( a == MOUSE_LEFT_SCROLL ) {
   mouseleftclip->SetValue(B_CONTROL_OFF);
   mouseleftdrag->SetValue(B_CONTROL_OFF);
   mouseleftscroll->SetValue(B_CONTROL_ON);
   mouseleftmenu->SetValue(B_CONTROL_OFF);
 }
 if ( a == MOUSE_LEFT_MENU ) {
   mouseleftclip->SetValue(B_CONTROL_OFF);
   mouseleftdrag->SetValue(B_CONTROL_OFF);
   mouseleftscroll->SetValue(B_CONTROL_OFF);
   mouseleftmenu->SetValue(B_CONTROL_ON);
 }

  // right
 if ( a == MOUSE_RIGHT_CLIP ) {   
   mouserightclip->SetValue(B_CONTROL_ON);
   mouserightdrag->SetValue(B_CONTROL_OFF);
   mouserightscroll->SetValue(B_CONTROL_OFF);
   mouserightmenu->SetValue(B_CONTROL_OFF);
 }
 if ( a == MOUSE_RIGHT_DRAG ) {
   mouserightclip->SetValue(B_CONTROL_OFF);
   mouserightdrag->SetValue(B_CONTROL_ON);
   mouserightscroll->SetValue(B_CONTROL_OFF);
   mouserightmenu->SetValue(B_CONTROL_OFF);
 }
 if ( a == MOUSE_RIGHT_SCROLL ) {
   mouserightclip->SetValue(B_CONTROL_OFF);
   mouserightdrag->SetValue(B_CONTROL_OFF);
   mouserightscroll->SetValue(B_CONTROL_ON);
   mouserightmenu->SetValue(B_CONTROL_OFF);
 }
 if ( a == MOUSE_RIGHT_MENU ) {
   mouserightclip->SetValue(B_CONTROL_OFF);
   mouserightdrag->SetValue(B_CONTROL_OFF);
   mouserightscroll->SetValue(B_CONTROL_OFF);
   mouserightmenu->SetValue(B_CONTROL_ON);
 }

  // middle
 if ( a == MOUSE_MIDDLE_CLIP ) {   
   mousemiddleclip->SetValue(B_CONTROL_ON);
   mousemiddledrag->SetValue(B_CONTROL_OFF);
   mousemiddlescroll->SetValue(B_CONTROL_OFF);
   mousemiddlemenu->SetValue(B_CONTROL_OFF);
 }
 if ( a == MOUSE_MIDDLE_DRAG ) {
   mousemiddleclip->SetValue(B_CONTROL_OFF);
   mousemiddledrag->SetValue(B_CONTROL_ON);
   mousemiddlescroll->SetValue(B_CONTROL_OFF);
   mousemiddlemenu->SetValue(B_CONTROL_OFF);
 }
 if ( a == MOUSE_MIDDLE_SCROLL ) {
   mousemiddleclip->SetValue(B_CONTROL_OFF);
   mousemiddledrag->SetValue(B_CONTROL_OFF);
   mousemiddlescroll->SetValue(B_CONTROL_ON);
   mousemiddlemenu->SetValue(B_CONTROL_OFF);
 }
 if ( a == MOUSE_MIDDLE_MENU ) {
   mousemiddleclip->SetValue(B_CONTROL_OFF);
   mousemiddledrag->SetValue(B_CONTROL_OFF);
   mousemiddlescroll->SetValue(B_CONTROL_OFF);
   mousemiddlemenu->SetValue(B_CONTROL_ON);
 }

// MOUSE DRAGGING STUFF

 if ( a== MOUSE_DRAG_BLEND ) {
   mousedragblend->SetValue(B_CONTROL_ON);
   mousedragcopy->SetValue(B_CONTROL_OFF);
   mousedraginvert->SetValue(B_CONTROL_OFF);
   mousedragicon->SetValue(B_CONTROL_OFF);
 }
 if ( a== MOUSE_DRAG_COPY ) {
   mousedragblend->SetValue(B_CONTROL_OFF);
   mousedragcopy->SetValue(B_CONTROL_ON);
   mousedraginvert->SetValue(B_CONTROL_OFF);
   mousedragicon->SetValue(B_CONTROL_OFF);
 }
 if ( a== MOUSE_DRAG_INVERT ) {
   mousedragblend->SetValue(B_CONTROL_OFF);
   mousedragcopy->SetValue(B_CONTROL_OFF);
   mousedraginvert->SetValue(B_CONTROL_ON);
   mousedragicon->SetValue(B_CONTROL_OFF);
 }
 if ( a== MOUSE_DRAG_ICON ) {
   mousedragblend->SetValue(B_CONTROL_OFF);
   mousedragcopy->SetValue(B_CONTROL_OFF);
   mousedraginvert->SetValue(B_CONTROL_OFF);
   mousedragicon->SetValue(B_CONTROL_ON);
 }

 if ( a== MOUSE_FILE_DROP ) mousefiledrop->SetValue(B_CONTROL_ON);
 if ( a== MOUSE_FILE_CHANGE ) mousefilechange->SetValue(B_CONTROL_ON); 

  
}

void MouseOptions::AttachedToWindow() {
 SetViewColor(Parent()->ViewColor());
 BView::AttachedToWindow();
}

// MOUSE WINDOW OPTIONS
