#ifndef _MOUSE_OPTIONS_H
#define _MOUSE_OPTIONS_H

#include <View.h>
#include <Box.h>
#include <CheckBox.h>
#include <StringView.h>

#define MOUSE_LEFT_CLIP 'MLCL'
#define MOUSE_LEFT_SCROLL 'MLSC'
#define MOUSE_LEFT_DRAG 'MLDR'
#define MOUSE_LEFT_MENU 'MLME'

#define MOUSE_RIGHT_CLIP 'MRCL'
#define MOUSE_RIGHT_SCROLL 'MRSC'
#define MOUSE_RIGHT_DRAG 'MRDR'
#define MOUSE_RIGHT_MENU 'MRME'

#define MOUSE_MIDDLE_CLIP 'MMCL'
#define MOUSE_MIDDLE_SCROLL 'MMSC'
#define MOUSE_MIDDLE_DRAG 'MMDR'
#define MOUSE_MIDDLE_MENU 'MMME'

#define MOUSE_DRAG_BLEND 	'MDBL'
#define MOUSE_DRAG_COPY 	'MDCO'
#define MOUSE_DRAG_INVERT 	'MDIN'
#define MOUSE_DRAG_ICON 	'MDIC'

#define MOUSE_FILE_DROP		'MFDP'
#define MOUSE_FILE_CHANGE	'MFCH'


class MouseOptions: public BView {
  public:
   MouseOptions(BRect,char*);
   virtual void AttachedToWindow();
   void Change(uint32);
  private:
   BCheckBox *mouseleftclip,
             *mouseleftdrag,
             *mouseleftmenu,
             *mouseleftscroll;
   BCheckBox *mouserightclip,
             *mouserightdrag,
             *mouserightmenu,
             *mouserightscroll;
   BCheckBox *mousemiddleclip,
             *mousemiddledrag,
             *mousemiddlemenu,
             *mousemiddlescroll;
   BCheckBox *mousedragblend,
             *mousedragcopy,
             *mousedraginvert,
             *mousedragicon;
   BCheckBox *mousefiledrop,
             *mousefilechange;
};

#endif