//    Peek, An Image Viewing Program for BeOS
//    Copyright (C) 2000 Durand Miller
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, version 2.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

#include "PListItem.h"

PListItem::PListItem(BEntry *e, char *name = NULL) : BListItem()
{
 theFile = NULL;
 theFile = new entry_ref;
 e->GetRef(theFile);
 if (name == NULL) e->GetName(theName);
 else strcpy(theName,name);  
 if (e->IsDirectory()) isDirectory = true;
    else isDirectory = false;
}

PListItem::~PListItem() {
  if (theFile != NULL) delete theFile;
}

// GetEntry - requires that e be declared before the method is entered!
int32 PListItem::GetEntry(BEntry *e) {
 if (theFile == NULL) return B_ERROR;
 BEntry *tempy = new BEntry(theFile);
 *e = *tempy;
 delete tempy;
 return B_OK;
}

// GetRef - requires that p be declared before the method is entered!
int32 PListItem::GetRef(entry_ref *p) {
 if (theFile == NULL) return B_ERROR;
 *p = *theFile;
 return B_OK;
}


void PListItem::DrawItem(BView *owner, BRect frame, bool complete) {
  owner->SetDrawingMode(B_OP_OVER);
  if (complete) {
    owner->SetHighColor(owner->ViewColor());
    owner->FillRect(frame);
  }  
  if (IsSelected()) { 
     owner->SetHighColor(142,142,142,255);
     owner->FillRect(frame);
   }  else {
   }


  if (isDirectory) {
     owner->SetHighColor(100,0,0,0);
     owner->MovePenTo(frame.left+4, frame.bottom-2);
  } else { 
      owner->SetHighColor(0,0,0,0);
      owner->MovePenTo(frame.left+10, frame.bottom-2);
    }     

  owner->DrawString(theName);
}
