#ifndef _PEEK_CONFIGURATION_H
#define _PEEK_CONFIGURATION_H

#include <OS.h>
#include <View.h>

class PeekConfiguration {
  public:
    void SetVersion(char[10]);
    void GetVersion(char*);
    void SetSlideshowDelay(bigtime_t);
    bigtime_t SlideshowDelay();
    int SlideshowMode();
    int ViewMode();
    void SetViewMode(int);
    bool FullScreen();
    void SetFullScreen(bool);
    void SetSlideshowMode(int);
    void SetLeftButton(uint32);
    void SetRightButton(uint32);
    void SetMiddleButton(uint32);
    void SetDragMode(drawing_mode);
    void SetChangeDirectory(bool);
    bool ChangeDirectory();
    void SetOpenCompact(bool);
    bool OpenCompact();
    void SetFileDrop(bool);
    bool FileDrop();
    void SetRunFile(bool m);
    bool RunFile();
    void SetDeleteAll(bool m);
    bool DeleteAll();
    void SetChangeOnDesktopLoad(bool m);
    bool ChangeOnDesktopLoad();
    int32 FileListRight();
    void SetFileListRight(int32);
    bool FileListHide();
    void SetFileListHide(bool);
    drawing_mode DragMode();
    uint32 LeftButton();
    uint32 RightButton();
    uint32 MiddleButton();
    BRect Frame();
    void SetFrame(BRect);
  private:
    char version[10];
    BRect frame;
    uint32 leftMouse,rightMouse,middleMouse;
    drawing_mode dragMode;
    bigtime_t slideshowDelay;
    int32 fileListRight;
    int slideshowMode;
    int viewMode;
    bool fullScreen, fileDrop, changeDirectory, runFile, deleteAll, changeOnDesktopLoad, fileListHide, openCompact;
    int leftMouseValue,rightMouseValue,middleMouseValue;
};

#endif

