//    Peek, An Image Viewing Program for BeOS
//    Copyright (C) 2000 Durand Miller
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, version 2.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

#include "PeekWindow.h"

PeekWindow::PeekWindow(BRect R, char *name, PeekConfiguration *s) 
: BWindow( R,name, B_DOCUMENT_WINDOW, B_WILL_ACCEPT_FIRST_CLICK, B_CURRENT_WORKSPACE)
{
  Setup = s;
  Lock();
  srandom(system_time());
  slideMode = false;
  SetSizeLimits(100,5000,100,5000);      // I hope this accomodates everyone.
// Menu!
  BRect *box = new BRect(0,0,0,0);      // <----  my BeBoX
  
  // Setting up window shortcuts here :)
  AddShortcut(B_BACKSPACE,0,new BMessage(PEEK_LIST_UP));

  menuBar = new BMenuBar(*box,"menuBar");  

  BMenu *tempItem = new BMenu("File");
  BMenu *tempItemB;

    tempItem->AddItem(MakeSaveMenu("Save As..."));
    tempItem->AddItem(new BMenuItem("Move to Trash",new BMessage(PEEK_FILE_DELETE),'T'));
    tempItem->AddSeparatorItem();
    tempItem->AddItem(new BMenuItem("Quit",new BMessage(PEEK_QUIT),'Q'));
  menuBar->AddItem(tempItem);

  // Edit menu
  tempItem = new BMenu("Edit");
    tempItem->AddItem(new BMenuItem("Copy",new BMessage(PEEK_CLIPBOARD_COPY),'C'));
    tempItem->AddItem(new BMenuItem("Paste",new BMessage(PEEK_CLIPBOARD_PASTE),'V'));
  menuBar->AddItem(tempItem);


 // Options menu
  tempItem = new BMenu("Options");
    //  view mode radio menu
    tempItemB= new BMenu("Viewing Modes");
     tempItemB->SetRadioMode(true);
     tempItemB->AddItem(new BMenuItem("Normal", new BMessage(PEEK_IMAGE_NORMAL)));
     tempItemB->AddItem(new BMenuItem("Tiled", new BMessage(PEEK_IMAGE_TILED)));
     tempItemB->AddItem(new BMenuItem("Stretched to window", new BMessage(PEEK_IMAGE_STRETCH)));
     tempItemB->AddItem(new BMenuItem("Window resized to image", new BMessage(PEEK_IMAGE_RESIZE)));
    tempItem->AddItem(tempItemB);

  tempItem->AddSeparatorItem();
 
       // Slideshow modes.
   tempItemB= new BMenu("Slide Show Modes");
     tempItemB->SetRadioMode(true);
     tempItemB->AddItem(new BMenuItem("Descending", new BMessage(PEEK_SLIDE_DESCEND)));
     tempItemB->AddItem(new BMenuItem("Ascending", new BMessage(PEEK_SLIDE_ASCEND)));
     tempItemB->AddItem(new BMenuItem("Random", new BMessage(PEEK_SLIDE_RANDOM)));
   tempItem->AddItem(tempItemB);

   tempItem->AddSeparatorItem();
   tempItem->AddItem(new BMenuItem("Options...", new BMessage(PEEK_OPTIONS_WINDOW), 'O'));

   menuBar->AddItem(tempItem);

// VIEW menu
   tempItem = new BMenu("View");
     tempItem->AddItem(new BMenuItem("Toggle File List", new BMessage(PEEK_FILES_HIDE),'H'));
     tempItem->AddItem(new BMenuItem("Toggle Full Screen", new BMessage(PEEK_FULL_SCREEN),'F'));
     tempItem->AddItem(new BMenuItem("Toggle Slide Show", new BMessage(PEEK_SLIDE_TOGGLE), 'S') );
   menuBar->AddItem(tempItem);

// Image menu
  BMenu *tempItemA;

  tempItem = new BMenu("Image");
    tempItemB= new BMenu("Set as Desktop");
      tempItemA = new BMenu("current");
        tempItemA->AddItem(new BMenuItem("Tiled", new BMessage(PEEK_DESKTOP_TILED)));
        tempItemA->AddItem(new BMenuItem("Centered", new BMessage(PEEK_DESKTOP_CENTERED)));
        tempItemA->AddItem(new BMenuItem("Scaled", new BMessage(PEEK_DESKTOP_SCALED)));
        tempItemA->AddItem(new BMenuItem("Manual Placement", new BMessage(PEEK_DESKTOP_MANUAL)));
      tempItemB->AddItem(tempItemA);
      tempItemA = new BMenu("all");
        tempItemA->AddItem(new BMenuItem("Tiled", new BMessage(PEEK_ALL_DESKTOP_TILED)));
        tempItemA->AddItem(new BMenuItem("Centered", new BMessage(PEEK_ALL_DESKTOP_CENTERED)));
        tempItemA->AddItem(new BMenuItem("Scaled", new BMessage(PEEK_ALL_DESKTOP_SCALED)));
        tempItemA->AddItem(new BMenuItem("Manual Placement", new BMessage(PEEK_ALL_DESKTOP_MANUAL)));
      tempItemB->AddItem(tempItemA);
    tempItem->AddItem(tempItemB);

    tempItem->AddItem(new BMenuItem("Load Desktop Background", new BMessage(PEEK_DESKTOP_LOAD)));

    tempItemB= new BMenu("Screen Capture");
      tempItemB->AddItem(new BMenuItem("Without Peek", new BMessage(PEEK_CAPTURE_NO_PEEK),'M'));
      tempItemB->AddItem(new BMenuItem("With Peek", new BMessage(PEEK_CAPTURE_PEEK)));
    tempItem->AddItem(tempItemB);

  menuBar->AddItem(tempItem);


// Help menu
  tempItem = new BMenu("Help");
    tempItem->AddItem( new BMenuItem("Help!", new BMessage(PEEK_HELP_HELP)));
    tempItem->AddItem( new BMenuItem("About", new BMessage(B_ABOUT_REQUESTED)));
  menuBar->AddItem(tempItem);

  AddChild(menuBar);

// ---------------- finished menu



// Background color

  *box = Bounds();
  box->top = menuBar->Bounds().bottom + 1; 
  alles = new BView(Bounds(),"everything", B_FOLLOW_ALL_SIDES, B_WILL_DRAW | B_FRAME_EVENTS);
  alles->SetViewColor(menuBar->ViewColor());

// Image View!
  *box = Bounds();
  box->top = menuBar->Bounds().bottom + 6;
  box->left = Setup->FileListRight() + 10 + B_V_SCROLL_BAR_WIDTH;
  box->right = box->right - B_V_SCROLL_BAR_WIDTH;
  box->bottom = box->bottom - B_H_SCROLL_BAR_HEIGHT;
  picView = new ImageView(*box,"background_pic",Setup, negotiationMessage);
  imageScrollView = new BScrollView("picScroll",picView,B_FOLLOW_ALL_SIDES, B_FRAME_EVENTS, true,true, B_FANCY_BORDER);

 // setting the whole span of the VIEW
  alles->AddChild(imageScrollView);
  picView->AdjustScrollBars();

// Setting up the SlideView
  box->right = box->left - 1;  // should still be just left of the imageView
  box->left = Setup->FileListRight() + B_V_SCROLL_BAR_WIDTH + 1;
  sliderBar = new SlideView(*box,"slideView");
  sliderBar->SetViewColor( menuBar->ViewColor() );
  alles->AddChild( sliderBar );


// File List here
  box->right = Setup->FileListRight();
  box->left = 5;
  box->bottom = box->bottom - 5;

  fileView = new PListView(*box,"fileView",B_SINGLE_SELECTION_LIST, B_FOLLOW_LEFT | B_FOLLOW_TOP_BOTTOM, B_WILL_DRAW | B_FRAME_EVENTS);
  fileView->SetSelectionMessage(  new BMessage(PEEK_LOAD) );  
  fileView->SetInvocationMessage( new BMessage(PEEK_INVOKE) );

  fileScrollView = new BScrollView("fileList",fileView,B_FOLLOW_LEFT | B_FOLLOW_TOP_BOTTOM, B_FRAME_EVENTS ,true,true,B_PLAIN_BORDER);
  alles->AddChild( fileScrollView );
  fileScrollView->SetViewColor(menuBar->ViewColor());

// Path information
  currentPath = new BPath("./");


  AddChild(alles);

  if (Setup->FullScreen()) {
   Setup->SetFullScreen(false);
   ToggleFullScreen();
  }

  if (Setup->FileListHide()) {
    Setup->SetFileListHide(false);
    ToggleFileList();
  } 

  fileView->MakeFocus(true);

  delete box;
  Unlock();

  RefreshFileView();     // This should go elsewhere

}


// MakeSaveMenu - this returns a BMenu* with the name passed in.  It also sets up the
//                neogitationMessage which is sent everytime someone tries to drag an
//                image out of the imageView
BMenu* PeekWindow::MakeSaveMenu(char*name) {
  // setting up our negotiation message for any other applications.
  negotiationMessage = new BMessage(B_SIMPLE_DATA);
  // see ***************************************
    BMenu *tempItemB= new BMenu("Save As");

    translator_id *list;
    int32 num;
    BTranslatorRoster::Default()->GetAllTranslators(&list,&num);
 
      for (int i=0; i < num; i++) {
         int32 numOfTypes;
         const translation_format *in_types,*out_types;            // WE'RE LOOKING FOR ALL TYPES THAT ACCEPT BBITMAPS AS INPUT
         BTranslatorRoster::Default()->GetInputFormats(list[i],&in_types,&numOfTypes);
         
         for (int j = 0; j <numOfTypes; j++) {
          if (in_types[j].type == B_TRANSLATOR_BITMAP) {
             BTranslatorRoster::Default()->GetOutputFormats(list[i],&out_types,&numOfTypes);
              for (int po = 0; po < numOfTypes; po ++) 
                if (out_types[po].type != B_TRANSLATOR_BITMAP) {
                   // **************************************************************
                   // Set up the external negotiation message
                   negotiationMessage->AddString("be:types",out_types[po].MIME);
                   negotiationMessage->AddString("be:filetypes",out_types[po].MIME);
                   negotiationMessage->AddString("be:type_descriptions",out_types[po].name); 

                   // Now we set up the internal messages
                   BMessage *msg = new BMessage(PEEK_FILE_SAVE);
                   msg->AddInt32("translator_id",list[i]);
                   msg->AddInt32("type_const",out_types[po].type);
                   msg->AddString("mime_type",out_types[po].MIME);
                   tempItemB->AddItem(new BMenuItem(out_types[po].name,msg));
                 }   
              break;
          }
         }
      }


    negotiationMessage->AddString("be:types",B_FILE_MIME_TYPE);
    negotiationMessage->AddInt32("be:actions",B_COPY_TARGET);
    negotiationMessage->AddInt32("be:actions",B_MOVE_TARGET);
    negotiationMessage->AddInt32("be:actions",B_TRASH_TARGET);
    negotiationMessage->AddString("be:clip_name","Peek clipping");
    // **************** negotiation message set up now. 

  return tempItemB;
}


// ShowHTML - locates the executable's path, finds that path's parent,
//            appends the Peek.html to it and then asks Tracker to execute it.
void PeekWindow::ShowHTML() {
  app_info *peekInfo = new app_info;
  be_app->GetAppInfo(peekInfo);  // got the exe path

  BEntry *appEntry = new BEntry(&peekInfo->ref);
  BPath *appPath = new BPath;
  appEntry->GetPath(appPath);
  appPath->GetParent(appPath);     // got the parent

  char sammy[B_FILE_NAME_LENGTH];

  strcpy(sammy,appPath->Path());
  strcat(sammy,"/html/index.html");
  BEntry kop(sammy);
  kop.GetRef(&peekInfo->ref);
  if (be_roster->Launch(&peekInfo->ref) != B_OK ) {
    (new BAlert("missingAlert", "The html directory or the files are missing from your installation. If you really need help, please download the full Peek at http://pws.prserv.net/durand/peek/ . Sorry about the inconvenience.", "Ok"))->Go();
  }

  delete peekInfo;
  delete appEntry;
  delete appPath;
}


// CleanListView - Removes all the PListItems from the PListView
//                 and deletes them. They aren't deleted automatically
//                 so we have to do this.
void PeekWindow::CleanListView(PListView* poorView) {
  PListItem *forDeletion;
  forDeletion = (PListItem*)poorView->RemoveItem((long int)0);
  while (forDeletion != NULL) {
   delete forDeletion;
   forDeletion = (PListItem*)poorView->RemoveItem((long int)0);
  } 
}

// RefreshFileView - This cleans the fileView, then adds all the entries
//                   in the current directory to it for a new Path.
//                   It also sets up the node monitor for the current directory
void PeekWindow::RefreshFileView() {
  Lock();
  stop_watching(be_app_messenger); // stop watching any directory changes
  fileView->Hide();        // hide it 'cos sometimes it takes forever to load a large list
  CleanListView(fileView);
  BDirectory *currentDirectory = new BDirectory(currentPath->Path());

  node_ref thisDirRef;        // our node ref
  currentDirectory->GetNodeRef(&thisDirRef);

  BEntry *tempEntry = new BEntry;
   currentDirectory->GetEntry(tempEntry);

  if (tempEntry->GetParent(tempEntry) == B_OK)      // got parent.
    fileView->AddItem( new PListItem(tempEntry, "..")); // only add if there is one, should get rid of the root dir showing up here.
  
  currentDirectory->Rewind();
  while (currentDirectory->GetNextEntry(tempEntry, true) == B_OK) 
    fileView->AddItem( new PListItem(tempEntry) );

  watch_node(&thisDirRef, B_WATCH_DIRECTORY, be_app_messenger); // watch this new directory for alterations

  delete currentDirectory;
  delete tempEntry;
  fileView->Show();       // show it again
  Unlock();
}


// ImageType - returns true if *p has a super-type "image", false if not.
bool PeekWindow::ImageType(BEntry *p) {
 bool ans = false;
 BNode *tempNode = new BNode(p);
 BNodeInfo *tempNodeInfo = new BNodeInfo(tempNode);
 
 char mime_type[B_MIME_TYPE_LENGTH];
 tempNodeInfo->GetType(mime_type);
 BMimeType *tempMimeType = new BMimeType(mime_type);
 BMimeType *imageMimeType = new BMimeType("image");
 
 ans = imageMimeType->Contains(tempMimeType);
 
 delete imageMimeType;
 delete tempMimeType;
 delete tempNode;
 delete tempNodeInfo;
 return ans;
}

// Invoked - This is called whenever an item in the file list is invoked.
void PeekWindow::Invoked() {
  if (fileView->CurrentSelection() < 0 ) return;
  BEntry *suspect = new BEntry();
  ((PListItem*)fileView->ItemAt(fileView->CurrentSelection()))->GetEntry(suspect);

  if (suspect->IsDirectory()) {
   delete currentPath;
   currentPath = new BPath(suspect);
   RefreshFileView();
   delete suspect;
   return;
  }

 if (ImageType(suspect)) {
  LoadImage(suspect);
  delete suspect;
  return;
 } 

 if (Setup->RunFile()) {
    entry_ref *toRun = new entry_ref;
    suspect->GetRef(toRun);
    be_roster->Launch(toRun);
    delete toRun;
    delete suspect;
    return;
 }   

}

// LoadImage - this is the window's LoadImage method. It accepts BEntry's
int32 PeekWindow::LoadImage(BEntry *target) {
  if (target->IsDirectory() || !target->IsFile()) return B_ERROR;   

//  Lock();
  if (picView->loadImage(target) == B_OK) {
 //    Unlock();
     if (Setup->ViewMode()==P_WINDOW) ResizeToImageView();
     picView->AdjustScrollBars();

          // the picture was loaded succesfully. Does the user want us to change directories?
          if (Setup->ChangeDirectory()) {
            entry_ref ref;
            BEntry *dropped = new BEntry();
            target->GetParent(dropped);
            dropped->GetRef(&ref);
            delete dropped;
            ChangeDirectory(&ref);
          }

    return B_OK;
  } 
//  Unlock();

 return B_ERROR;
}

// LoadImage - this is the numerical front of the LoadImage method. It loads
//             the BEntry at the num'th position in the file view.
int32 PeekWindow::LoadImage(int32 num) {
 BEntry *loadTemp = new BEntry();
 ((PListItem*)(fileView->ItemAt(num))) ->GetEntry(loadTemp);
 int32 res = LoadImage( loadTemp );
 delete loadTemp;
 return res;
}

// LoadImage - this is the entry_ref front of the LoadImage method. It loads
//             the entry_ref passed to it
int32 PeekWindow::LoadImage(entry_ref *k) {
 BEntry *loadTemp = new BEntry(k);
 int32 res = LoadImage( loadTemp );
 delete loadTemp;
 return res;
}



// QuitRequested
bool PeekWindow::QuitRequested() {
 Hide();    // Sometimes it takes a while to unload a large directory, so hide this window to make it appear as if it quit while it unloads.
 be_app->PostMessage(B_QUIT_REQUESTED);
 delete negotiationMessage;
 delete currentPath;
 fileView->Hide();  // 'cos it looks ugly when it's unloading all it's info
 CleanListView(fileView);
 fileView->Show();  // is this really necessary since we're quitting?
 return true;
}

// FrameResized
void PeekWindow::FrameResized(float height,float width) {
  picView->Refresh();
  if (!Setup->FullScreen()) Setup->SetFrame(Frame());
}

// ResizeToImageView
void PeekWindow::ResizeToImageView() {
 if (Setup->FullScreen()) return;
 float x,y;
 picView->RequestedSize(&x,&y);
 if (x < 50) x = 50;
 if (y < 50) y = 50;
 float calcx = Bounds().Width() - picView->Bounds().Width() + x;
 float calcy = Bounds().Height() - picView->Bounds().Height() + y;
  // make sure it doesn't extend past the limits of the screen
   BScreen *checkScreen = new BScreen();
    if (calcx + Frame().left > checkScreen->Frame().right)
      calcx = checkScreen->Frame().right - Frame().left - 20;
    if (calcy + Frame().top > checkScreen->Frame().bottom)
      calcy = checkScreen->Frame().bottom - Frame().top - 20;
   delete checkScreen;
  // done checking.
 ResizeTo(calcx,calcy);
}

// SliderMoved - this handles any movement by the user of the sliderBar
//               float x should be the displacement. - is left, + is right
//            
//               Perhaps someone could help.  It's not very pretty when it 
//               moves around and I don't know why at the moment.
void PeekWindow::SliderMoved(float x) {
        // keep it inside the window
    if (Setup->FileListRight() < 10 && x < 0) return;
    if (Setup->FileListRight() > Bounds().right - 50 && x > 0) return;

        // update every view.
    Setup->SetFileListRight(Setup->FileListRight() + x);
  
    Lock();
    imageScrollView->MoveBy(x,0);
    imageScrollView->ResizeBy(-x,0);
    fileScrollView->ResizeBy(x,0);
    fileView->ResizeBy(x,0);
    sliderBar->MoveBy(x,0);
    picView->AdjustScrollBars();
    Unlock();
}

// doFullScreen
void PeekWindow::ToggleFullScreen() {
  Lock();
  if (Setup->FullScreen()) {
   MoveTo(Setup->Frame().left,Setup->Frame().top);
   ResizeTo(Setup->Frame().Width(),Setup->Frame().Height());
   SetFlags(0);
   Setup->SetFullScreen(false);
  } 
   else {  
     BScreen *thisScreen = new BScreen();
     Setup->SetFullScreen(true);
     Setup->SetFrame(Frame());
     MoveTo(0,0);
     ResizeTo(thisScreen->Frame().Width(),thisScreen->Frame().Height());    // OKAY.. Can't figure out where the screen_info is defined
     delete thisScreen;
     SetFlags(B_NOT_RESIZABLE | B_NOT_MOVABLE);
  }   
  Unlock();
}

// DeleteFile!
void PeekWindow::DeleteFile() {
  entry_ref doomedFile;
  BEntry *doomed;

  if (picView->GetRef(&doomedFile) == B_ERROR) {
    if (!Setup->DeleteAll()) return;
    if (fileView->CurrentSelection() < 1) return;
    doomed = new BEntry();
    ((PListItem*)fileView->ItemAt(fileView->CurrentSelection()))->GetEntry(doomed);
  } else doomed = new BEntry(&doomedFile);
 
  if (!ImageType(doomed)) 
    if (!Setup->DeleteAll()) {
     delete doomed;
     return;
    }

  BPath *trashPath = new BPath(); 
 
  if (find_directory(B_TRASH_DIRECTORY,trashPath) == B_OK) {
     BDirectory *trashDirectory = new BDirectory(trashPath->Path());
     doomed->MoveTo(trashDirectory);     
     delete trashDirectory;
     int num = fileView->CurrentSelection();
     picView->Clear();
     picView->Refresh();
     RefreshFileView();
     fileView->Select(num);
 }   
  
  delete doomed;
  delete trashPath;
}

// save the actual file
void PeekWindow::FileSave(BMessage *msg) {
  int32 tid, type;
  translator_id trans_id;
  void *sourceData;
  const char *fileName;
  const char *mime_type;

  entry_ref *saveDirectory = new entry_ref;
  msg->FindInt32("translator_id",&tid);
  msg->FindInt32("type_const",&type);
  msg->FindString("mime_type",&mime_type);
  msg->FindPointer("bitmap_pointer", &sourceData);
  msg->FindString("name",&fileName);
  msg->FindRef("directory",saveDirectory);

  BBitmap *thePic = (BBitmap*)sourceData;
  trans_id = (translator_id)tid;
  uint32 type_const = (uint32)type;

  BBitmapStream *strm = new BBitmapStream(thePic);
  BEntry target(saveDirectory,true);
  target.GetRef(saveDirectory);
 
  BDirectory *targetDir = new BDirectory(saveDirectory);
  if (targetDir->InitCheck() == B_OK) {
     BFile *targetFile = new BFile(targetDir,fileName, B_WRITE_ONLY | B_CREATE_FILE | B_ERASE_FILE);
     if (targetFile->InitCheck() == B_OK) {
       BTranslatorRoster::Default()->Translate(trans_id,strm,NULL,targetFile,type_const);
       BNodeInfo *ni = new BNodeInfo(targetFile);
       ni->SetType(mime_type);
       delete ni;
       delete targetFile;
         BEntry *newFile = new BEntry;      // fixes the not recognizing a save problem
         if (targetDir->FindEntry(fileName,newFile) == B_OK) {
           Lock();
           LoadImage(newFile); 
           Unlock();
          } 
         delete newFile;
     }  
  }
  strm->DetachBitmap(&thePic);  

  delete saveDirectory;
  delete strm;
  delete targetDir;
  delete saveWindow;
}

// SaveFile!   sets up the message for the new saveWindow()
void PeekWindow::SaveFile(BMessage *msg) {
  if (picView->GetBitmap()==NULL) return;
  BMessage *msg2 = new BMessage(*msg);
  msg2->what = PEEK_SAVE_FILE;
  msg2->AddPointer("bitmap_pointer", picView->GetBitmap());
  saveWindow = new BFilePanel(B_SAVE_PANEL);
  saveWindow->SetMessage(msg2);
  saveWindow->Show();
}


// ToggleFileList -  I think this is different to the other toggle methods in that the
//                   actual value is FileListHide is changed in here rather that before
//                   the method is called.
void PeekWindow::ToggleFileList() {
  // TOGGLELING ETC... the file list. Hide/Show
 if (!Setup->FileListHide()) {
  fileScrollView->Hide();
  sliderBar->Hide();
  imageScrollView->ResizeBy( Setup->FileListRight() + B_V_SCROLL_BAR_WIDTH + 11, 0);
  imageScrollView->MoveBy(-Setup->FileListRight() - B_V_SCROLL_BAR_WIDTH - 11,0);
  Setup->SetFileListHide(true);
 } else  {
  imageScrollView->ResizeBy( -Setup->FileListRight() - B_V_SCROLL_BAR_WIDTH - 11, 0);
  imageScrollView->MoveBy(Setup->FileListRight() + B_V_SCROLL_BAR_WIDTH + 11,0);
  fileScrollView->Show();
  sliderBar->Show();
  Setup->SetFileListHide(false);
 } 

 picView->AdjustScrollBars();
}


// Message Listener for PeekWindow
void PeekWindow::MessageReceived(BMessage* e) {
   switch (e->what) {
    // window settings 
    case PEEK_FULL_SCREEN:		ToggleFullScreen(); break;
    case PEEK_FILES_HIDE:		ToggleFileList(); break;
    
    // image viewing options
    case PEEK_IMAGE_TILED:		Setup->SetViewMode(P_TILED); picView->Refresh();  break;
    case PEEK_IMAGE_NORMAL: 	Setup->SetViewMode(P_NORMAL); picView->Refresh(); 
                                break;
    case PEEK_IMAGE_STRETCH: 	Setup->SetViewMode(P_STRETCHED); picView->Refresh(); 
                                break;
    case PEEK_IMAGE_RESIZE: 	Setup->SetViewMode(P_WINDOW); 
                                picView->Refresh();
                                if (!Setup->FullScreen()) {ResizeToImageView(); picView->AdjustScrollBars(); } 
                                break;

    // image viewing options
    case PEEK_SLIDE_RANDOM:		Setup->SetSlideshowMode(P_RANDOM); break;
    case PEEK_SLIDE_ASCEND:		Setup->SetSlideshowMode(P_ASCEND); break;
    case PEEK_SLIDE_DESCEND:	Setup->SetSlideshowMode(P_DESCEND); break;
    case PEEK_SLIDE_TOGGLE:	    slideMode = !slideMode;  ToggleSlideshow(); break;

    // desktop background options
    case PEEK_DESKTOP_TILED:	SetDesktopBackground(B_BACKGROUND_MODE_TILED); break;
    case PEEK_DESKTOP_SCALED:	SetDesktopBackground(B_BACKGROUND_MODE_SCALED); break;
    case PEEK_DESKTOP_MANUAL:	SetDesktopBackground(B_BACKGROUND_MODE_USE_ORIGIN); break;
    case PEEK_DESKTOP_CENTERED:	SetDesktopBackground(B_BACKGROUND_MODE_CENTERED); break;

     // all desktops
    case PEEK_ALL_DESKTOP_TILED:	SetAllDesktopBackground(B_BACKGROUND_MODE_TILED); break;
    case PEEK_ALL_DESKTOP_SCALED:	SetAllDesktopBackground(B_BACKGROUND_MODE_SCALED); break;
    case PEEK_ALL_DESKTOP_MANUAL:	SetAllDesktopBackground(B_BACKGROUND_MODE_USE_ORIGIN); break;
    case PEEK_ALL_DESKTOP_CENTERED:	SetAllDesktopBackground(B_BACKGROUND_MODE_CENTERED); break;

    case PEEK_DESKTOP_LOAD:		GetDesktopBackground(); break;
 
    // screen capture options
    case PEEK_CAPTURE_PEEK:		CaptureScreen(true); break;
    case PEEK_CAPTURE_NO_PEEK:	CaptureScreen(false); break;

    // clipboard
    case PEEK_CLIPBOARD_COPY:	picView->ClipboardCopy(); break;
    case PEEK_CLIPBOARD_PASTE:	picView->ClipboardPaste(); break;

    // file menu options
    case PEEK_FILE_SAVE:	SaveFile(e); break;    // erg
    case PEEK_SAVE_FILE:	FileSave(e); break;
//    case PEEK_LIST_UP: 		Invoked(); break;
    case PEEK_INVOKE: 		Invoked(); break;
    case PEEK_LOAD: 		WaitASec(); break;
    case PEEK_HELP_HELP:	ShowHTML(); break;
    case PEEK_QUIT:   		PostMessage(B_QUIT_REQUESTED); break;

    default: be_app->PostMessage(e);
   }
}

void PeekWindow::ChangeDirectory(entry_ref *e) {
 entry_ref *newDir = new entry_ref(*e);
 BEntry *tempEntry = new BEntry(newDir, true);
 if (tempEntry->IsDirectory()) {
   BPath *tempPath = new BPath(tempEntry);
    if (strcmp(currentPath->Path(),tempPath->Path()) != 0)  {  // same directory? why refresh..
      currentPath->SetTo(tempEntry);
      RefreshFileView();
    }  
    delete tempPath;
    picView->GetRef(newDir);      // get rid of the selection message now.
    uint32 command = fileView->SelectionCommand();
    fileView->SetSelectionMessage(NULL);
    fileView->Select( fileView->IndexOf( *newDir) );
    fileView->SetSelectionMessage(new BMessage(command));
    fileView->ScrollToSelection();
 } 
 delete newDir;
 delete tempEntry;
}

void PeekWindow::CaptureScreen(bool h) {
  Lock();
  if (!h) Hide();
   BScreen *desk = new BScreen();
   BBitmap *screenDump;
   UpdateIfNeeded();
   snooze(1000000);  // safety snooze to ensure the screen is all refreshed.  Perhaps is should be larger to account for slower systems?
   desk->GetBitmap(&screenDump);
   picView->loadImage(screenDump);  // can't delete the BBitmap 'cos it's not ours anymore.
   picView->AdjustScrollBars();
   delete desk;
  if (!h) Show();
  Unlock();
}

void PeekWindow::SetDesktopBackground(int32 mode) {
 char fileName[B_PATH_NAME_LENGTH];
 if (picView->GetFilename(fileName)) {
   (new BAlert("saveFirst","Please save the file first.","yeah ok"))->Go();
   return;
 }  

 BMessage msg,reply, wakeup;

 BPath *desktopPath = new BPath();
 find_directory(B_DESKTOP_DIRECTORY,desktopPath);
 BDirectory *desktopDirectory = new BDirectory(desktopPath->Path());

 if (desktopDirectory->InitCheck() == B_OK) {
   attr_info d_info;

   if (desktopDirectory->GetAttrInfo(B_BACKGROUND_INFO,&d_info) == B_OK) {
        char *buffer = new char[d_info.size];
        desktopDirectory->ReadAttr(B_BACKGROUND_INFO,d_info.type,0,buffer,d_info.size);
        msg.Unflatten(buffer);

        long int workspaceNum = 0;
          while (( ((uint32) msg.FindInt32(B_BACKGROUND_WORKSPACES,workspaceNum) & Workspaces()) == 0) && 
                  (msg.FindInt32(B_BACKGROUND_WORKSPACES,workspaceNum)!=0 )) 
                  workspaceNum++;
                   
           // HERE comes the setting....   if there is a desktop , do this
           if ( ((uint32)msg.FindInt32(B_BACKGROUND_WORKSPACES,workspaceNum)) == Workspaces() ) {
              msg.ReplaceString( B_BACKGROUND_IMAGE, workspaceNum, fileName);
              msg.ReplaceInt32( B_BACKGROUND_MODE, workspaceNum, mode);
             } else {  // if not, do another one

                // firstly, is the image shared?
              if ( ((uint32) msg.FindInt32(B_BACKGROUND_WORKSPACES,workspaceNum)) != Workspaces() ) {
                 // if so, remove this current desktop from the shared list
                 uint32 bob = (uint32)msg.FindInt32(B_BACKGROUND_WORKSPACES,workspaceNum) - Workspaces();
                 msg.ReplaceInt32( B_BACKGROUND_WORKSPACES, workspaceNum, bob );  // everyone but this one
              }

              msg.AddString( B_BACKGROUND_IMAGE, fileName);
              msg.AddInt32( B_BACKGROUND_WORKSPACES, Workspaces());
              msg.AddInt32( B_BACKGROUND_MODE, mode);
              msg.AddPoint( B_BACKGROUND_ORIGIN, BPoint(0,0));
              msg.AddBool( B_BACKGROUND_ERASE_TEXT, true);
              delete buffer;
              buffer = new char[msg.FlattenedSize()];
            }

          msg.Flatten(buffer, msg.FlattenedSize());
          desktopDirectory->WriteAttr(B_BACKGROUND_INFO,d_info.type,0,buffer,msg.FlattenedSize());
          delete buffer;
    } else { // if the Desktop directory doesn't have any background info!!!
       (new BAlert("unknown","There was trouble loading your desktop background settings. Peek won't continue and stuff up your machine. This exception will be supported one day.","Doesn't help me now."))->Go();
    }
 }


 delete desktopPath;
 delete desktopDirectory;

 wakeup.what = B_RESTORE_BACKGROUND_IMAGE;
 BMessenger("application/x-vnd.Be-TRAK").SendMessage(&wakeup,&reply);

 if (mode == B_BACKGROUND_MODE_USE_ORIGIN) be_roster->Launch("application/x-vnd.Be-BACK");
}

// SetAllDesktopBackground - This method will set the system-wide desktop background
//                           image to the currentPic displayed. It's not even going to bother
//                           to check if there's no data present, desktop doesn't have a background...
//                            ... uhh, yeah.
void PeekWindow::SetAllDesktopBackground(int32 mode) {
 char fileName[B_PATH_NAME_LENGTH];
 if (picView->GetFilename(fileName)) {
   (new BAlert("saveFirst", "Please save the file first.","yeah ok"))->Go();
   return;
 }  

 BMessage msg,reply, wakeup;

 BPath *desktopPath = new BPath();
 find_directory(B_DESKTOP_DIRECTORY,desktopPath);
 BDirectory *desktopDirectory = new BDirectory(desktopPath->Path());

 if (desktopDirectory->InitCheck() == B_OK) {
   attr_info d_info;                             // If I could just look into this, it would solve everything.
   if (desktopDirectory->GetAttrInfo(B_BACKGROUND_INFO,&d_info) == B_OK) {
       msg.AddString( B_BACKGROUND_IMAGE, fileName);
       msg.AddInt32( B_BACKGROUND_WORKSPACES, B_ALL_WORKSPACES);
       msg.AddInt32( B_BACKGROUND_MODE, mode);
       msg.AddPoint( B_BACKGROUND_ORIGIN, BPoint(0,0));
       msg.AddBool( B_BACKGROUND_ERASE_TEXT, true);
       char *buffer = buffer = new char[msg.FlattenedSize()];
            msg.Flatten(buffer, msg.FlattenedSize());
            desktopDirectory->WriteAttr(B_BACKGROUND_INFO,d_info.type,0,buffer,msg.FlattenedSize());
       delete buffer;
    } else 
     (new BAlert("noInfo", "Sorry. Peek kinda needs existing background info in the directory attributes.  Your's doesn't have any. Peek might stuff up so it won't do it.","nothing ever goes my way"))->Go();    
 }


 delete desktopPath;
 delete desktopDirectory;

 wakeup.what = B_RESTORE_BACKGROUND_IMAGE;
 BMessenger("application/x-vnd.Be-TRAK").SendMessage(&wakeup,&reply);

 if (mode == B_BACKGROUND_MODE_USE_ORIGIN) be_roster->Launch("application/x-vnd.Be-BACK");
}


// yup, load the desktop file
void PeekWindow::GetDesktopBackground() {
 BMessage msg;

 BPath *desktopPath = new BPath();
 find_directory(B_DESKTOP_DIRECTORY,desktopPath);
 BDirectory *desktopDirectory = new BDirectory(desktopPath->Path());

 if (desktopDirectory->InitCheck() == B_OK) {
   attr_info d_info;
   if (desktopDirectory->GetAttrInfo(B_BACKGROUND_INFO,&d_info) == B_OK) {

        char *buffer = new char[d_info.size];
        desktopDirectory->ReadAttr(B_BACKGROUND_INFO,d_info.type,0,buffer,d_info.size);

        if (msg.Unflatten(buffer) == B_OK) {
          long int workspaceNum = 0;      // ahhh, i spent years here because I didn't bracket correctly!
           while ( (((uint32) msg.FindInt32(B_BACKGROUND_WORKSPACES,workspaceNum)) & Workspaces()) != Workspaces()  &&
                   ((uint32) msg.FindInt32(B_BACKGROUND_WORKSPACES,workspaceNum)) != 0
                   ) workspaceNum++;

            if ( msg.FindInt32(B_BACKGROUND_WORKSPACES,workspaceNum) != 0) {
              BEntry *deskFile = new BEntry(msg.FindString(B_BACKGROUND_IMAGE,workspaceNum));
              LoadImage(deskFile); 
              if (Setup->ChangeOnDesktopLoad()) {
                 deskFile->GetParent(deskFile);
                 entry_ref deskPic;
                 deskFile->GetRef(&deskPic);
                 ChangeDirectory(&deskPic);
              }   
              delete deskFile;
          }
        }
       delete buffer; 

   }
 }


 delete desktopPath;
 delete desktopDirectory;
 picView->AdjustScrollBars();
}


void PeekWindow::FrameMoved(BPoint a) {
 if (!Setup->FullScreen()) Setup->SetFrame(Frame());
}

// YES ...... multithreading for zee selection list :)) makes nice. yummy.

int32 selectionListThread(void *data) {
 PeekWindow *targetWindow = (PeekWindow*)data;
 int32 selected = targetWindow->EntrySelected();
 snooze(700000);       //  could be smaller or larger
 if (selected == targetWindow->EntrySelected())
   targetWindow->ConfirmSelection(selected);    
 return B_OK;
}

void PeekWindow::WaitASec() {
  if (fileView->CurrentSelection() < 1) return;
  BEntry *currEnt = new BEntry();
  ((PListItem*)(fileView->ItemAt(fileView->CurrentSelection()))) ->GetEntry(currEnt);
  if (!ImageType(currEnt)) {
    delete currEnt;
    return;
  }  

  if (slideMode) {     // to prevent double loading during slideshow
    if (lastSlid != fileView->CurrentSelection()) 
      LoadImage( currEnt );
      delete currEnt;
    return;
  }

    Lock();
    selectThread = spawn_thread(selectionListThread, "peekSelection", B_NORMAL_PRIORITY, (void*)this);  
    resume_thread(selectThread);  
    Unlock();
  delete currEnt;
}

int32 PeekWindow::EntrySelected() {
 return fileView->CurrentSelection();
}

void PeekWindow::ConfirmSelection(int32 n) {
 Lock();
 if (fileView->CurrentSelection() == n) LoadImage( n );
 Unlock();
}


// YES....... multithreading for zee slideShow

bigtime_t PeekWindow::SlideshowDelay() {
 return Setup->SlideshowDelay();
}

// thread function
int32 slideshowThread(void *data) {
  PeekWindow *targetWindow = (PeekWindow*)data;
  snooze(targetWindow->SlideshowDelay());
  targetWindow->ToggleSlideshow();    
  return B_OK;
}

// ....... which calls this function

// ToggleSlideshow - actually controls the slideshow, starts the threads, ect..
//                   perhaps i should change the name.
void PeekWindow::ToggleSlideshow() {
  if (slideMode==false) return;

 Lock();
 int current = fileView->CurrentSelection();
 int beenHere = 0;             // prevents infinite looping if the routine can't find an image file.
 BEntry *k = new BEntry();
 do {
   if (current < 0) current = 0;
   if (Setup->SlideshowMode() == P_DESCEND) current++;
   if (Setup->SlideshowMode() == P_ASCEND) current--;
   if (Setup->SlideshowMode() == P_RANDOM) 
      do { current = random() % fileView->CountItems(); } while (current == fileView->CurrentSelection());
   if (current == fileView->CountItems()) current = 1;
   if (current < 1) current = fileView->CountItems() -1;

   if (beenHere++ > fileView->CountItems()) {  // check for infinite loop
      Unlock();
      return;
     };

   ((PListItem*)fileView->ItemAt(current))->GetEntry(k);
  } while (!ImageType( k ));
  LoadImage(k);
  delete k;

  lastSlid = current;
  fileView->Select(current);
  fileView->ScrollToSelection();


  slides = spawn_thread(slideshowThread, "peekSlideshow", B_NORMAL_PRIORITY, (void*)this);  
  resume_thread(slides);  
  Unlock();
}

