//    Peek, An Image Viewing Program for BeOS
//    Copyright (C) 2000 Durand Miller
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, version 2.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//


// SLIDE WINDOW OPTIONS
#include "SlideOptions.h"


SlideOptions::SlideOptions(BRect r,char*name):
 BView(r,name,B_FOLLOW_ALL_SIDES,0) 
{
 BRect *box = new BRect(175,15,430,150); 

 BBox *tempBox = new BBox(*box,"slideBox");

 tempBox->SetLabel("Delay");

 box->Set(30,20,220,10); 
 theSlider = new BSlider(*box,"slideshowSlider","Slideshow Delay",new BMessage(SLIDE_CHANGE),1,20);
   theSlider->SetHashMarks(B_HASH_MARKS_BOTH);
   theSlider->SetViewColor(255,200,200,0);
   rgb_color p = {200,200,255,0};
   theSlider->SetBarColor(p);
   theSlider->SetHashMarkCount(10); 
   theSlider->SetLimitLabels("Short","Long");
 tempBox->AddChild(theSlider);

 box->Set(90,70,200,100);
  display = new BStringView(*box,"display","Select delay");
 tempBox->AddChild(display); 


 AddChild(tempBox);
 slideBox = tempBox;

 box->Set(15,15,150,150); 
 tempBox = new BBox(*box,"slideWay");
 tempBox->SetLabel("Sequence");

 box->Set(15,30,100,20);
  forward = new BCheckBox(*box,"forwardBox","Descending",new BMessage(SLIDE_FORWARD));
  tempBox->AddChild(forward);
 box->Set(15,50,100,20);
  backward = new BCheckBox(*box,"backwardBox","Ascending",new BMessage(SLIDE_BACKWARD));
  tempBox->AddChild(backward);
 box->Set(15,70,100,20);
  random = new BCheckBox(*box,"randomBox","Random",new BMessage(SLIDE_RANDOM));
  tempBox->AddChild(random);

 AddChild(tempBox);
 delete box;
}

void SlideOptions::Flip(uint32 a) {
 switch (a) {
   case SLIDE_FORWARD: 		backward->SetValue(B_CONTROL_OFF); random->SetValue(B_CONTROL_OFF); forward->SetValue(B_CONTROL_ON); break;
   case SLIDE_BACKWARD: 	forward->SetValue(B_CONTROL_OFF); random->SetValue(B_CONTROL_OFF); backward->SetValue(B_CONTROL_ON);  break;
   case SLIDE_RANDOM: 		backward->SetValue(B_CONTROL_OFF); forward->SetValue(B_CONTROL_OFF); random->SetValue(B_CONTROL_ON);  break;
   default: break;
 }
}

bigtime_t SlideOptions::SliderValue() {
 switch (theSlider->Value()) {
   case 1:  return 500000;
   case 2:  return 1000000;
   case 3:  return 2000000;      
   case 4:  return 4000000;
   case 5:  return 5000000;
   case 6:  return 6000000;      
   case 7:  return 7000000;
   case 8:  return 8000000;
   case 9:  return 9000000;      
   case 10:  return 10000000;
   case 11:  return 15000000;
   case 12:  return 20000000;      
   case 13:  return 25000000;
   case 14:  return 30000000;
   case 15:  return 45000000;      
   case 16:  return 60000000;
   case 17:  return 120000000;
   case 18:  return 180000000;      
   case 19:  return 240000000;
   case 20:  return 300000000;
   default: return 2000000;
 }
}

void SlideOptions::SetSliderValue(bigtime_t a) {
 switch (a) {
   case 500000: theSlider->SetValue(1); break;
   case 1000000: theSlider->SetValue(2); break;
   case 2000000: theSlider->SetValue(3); break;      
   case 3000000: theSlider->SetValue(4);  break;      
   case 4000000: theSlider->SetValue(5); break;
   case 5000000: theSlider->SetValue(6); break;
   case 6000000: theSlider->SetValue(7); break;      
   case 7000000: theSlider->SetValue(8); break;
   case 8000000: theSlider->SetValue(9); break;
   case 9000000: theSlider->SetValue(10); break;      
   case 10000000: theSlider->SetValue(11); break;
   case 15000000: theSlider->SetValue(12); break;
   case 20000000: theSlider->SetValue(13); break;      
   case 25000000: theSlider->SetValue(14); break;
   case 30000000: theSlider->SetValue(15); break;
   case 45000000: theSlider->SetValue(16); break;      
   case 60000000: theSlider->SetValue(17); break;
   case 120000000: theSlider->SetValue(18); break;
   case 180000000: theSlider->SetValue(19); break;      
   case 300000000: theSlider->SetValue(20); break;
   default: break;
 }
}


void SlideOptions::Change() {
 switch (theSlider->Value()) {
   case 1:   display->SetText("1/2 a second"); break;
   case 2:  display->SetText("1 second"); break;
   case 3:  display->SetText("2 seconds");  break;      
   case 4:  display->SetText("3 seconds");  break;
   case 5:  display->SetText("4 seconds");  break;
   case 6:  display->SetText("5 seconds");  break;      
   case 7:  display->SetText("6 seconds");  break;
   case 8:  display->SetText("7 seconds");  break;
   case 9:  display->SetText("8 seconds");  break;      
   case 10:  display->SetText("9 seconds");  break;
   case 11:  display->SetText("10 seconds");  break;
   case 12:  display->SetText("15 seconds");  break;      
   case 13:  display->SetText("20 seconds");  break;      
   case 14:  display->SetText("25 seconds");  break;
   case 15:  display->SetText("30 seconds");  break;
   case 16:  display->SetText("45 seconds");  break;      
   case 17:  display->SetText("1 minute");  break;
   case 18:  display->SetText("2 minutes");  break;
   case 19:  display->SetText("3 minutes");  break;      
   case 20:  display->SetText("5 minutes");  break;
   default: break;;
 }
}

void SlideOptions::AttachedToWindow() {
 SetViewColor(Parent()->ViewColor());
 BView::AttachedToWindow();
}

// SLIDE WINDOW OPTIONS
