//    Peek, An Image Viewing Program for BeOS
//    Copyright (C) 2000 Durand Miller
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, version 2.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

#include "SlideView.h"

SlideView::SlideView(BRect R, char *name) 
: BView(R, name, B_FOLLOW_TOP_BOTTOM,0)
{
 mouseDown = false;
}

void SlideView::MouseDown( BPoint a) {
  mouseDown = true;
  SetMouseEventMask(1);
  downSpot = ConvertToScreen(a);
}

#include "PeekWindow.h"

void SlideView::MouseMoved( BPoint a, uint32, const BMessage* ) {
  if (mouseDown) {
    BPoint temp = ConvertToScreen(a);
     if (temp.x - downSpot.x > 2 || temp.x - downSpot.x < 2) {
        ((PeekWindow*)Window())->SliderMoved(temp.x-downSpot.x);  
        downSpot = temp;
     }  
  }
}

void SlideView::MouseUp( BPoint a) {
  mouseDown = false;
  SetMouseEventMask(0);
}
