//    Peek, An Image Viewing Program for BeOS
//    Copyright (C) 2000 Durand Miller
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, version 2.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

#include "ViewOptions.h"


ViewOptions::ViewOptions(BRect r,char*name):
 BView(r,name,B_FOLLOW_ALL_SIDES,0) 
{
 BRect *box = new BRect(15,15,200,150); 

 BBox *tempBox = new BBox(*box,"slideBox");
 tempBox->SetLabel("Viewing Modes");

 box->Set(10,30,180,0);
 viewNormal = new BCheckBox(*box,"viewNormal","Normal",new BMessage(VIEW_MODE_NORMAL));
 tempBox->AddChild(viewNormal);
 box->Set(10,50,180,0);
 viewTiled = new BCheckBox(*box,"viewTiled","Tiled",new BMessage(VIEW_MODE_TILED));
 tempBox->AddChild(viewTiled);
 box->Set(10,70,180,0);
 viewStretched = new BCheckBox(*box,"viewStretch","Stretched to window",new BMessage(VIEW_MODE_STRETCH));
 tempBox->AddChild(viewStretched);
 box->Set(10,90,180,0);
 viewWindow = new BCheckBox(*box,"viewWindow","Window resized to image",new BMessage(VIEW_MODE_WINDOW));
 tempBox->AddChild(viewWindow);

 AddChild(tempBox);

 box->Set(10,280,100,0);
 viewFileList = new BCheckBox(*box,"viewFileList","Hide the file list",new BMessage(VIEW_MODE_FILE_LIST));
 AddChild(viewFileList);
 box->Set(10,300,100,0);
 viewFullScreen = new BCheckBox(*box,"viewFullScreen","Full Screen",new BMessage(VIEW_MODE_FULL_SCREEN));
 AddChild(viewFullScreen);

 delete box;
}

void ViewOptions::AttachedToWindow() {
 SetViewColor(Parent()->ViewColor());
 BView::AttachedToWindow();
}

void ViewOptions::Change(uint32 a) {
 if (a==VIEW_MODE_NORMAL) {
   viewNormal->SetValue(B_CONTROL_ON);
   viewTiled->SetValue(B_CONTROL_OFF);
   viewWindow->SetValue(B_CONTROL_OFF);
   viewStretched->SetValue(B_CONTROL_OFF);
 }
 if (a==VIEW_MODE_TILED) {
   viewNormal->SetValue(B_CONTROL_OFF);
   viewTiled->SetValue(B_CONTROL_ON);
   viewWindow->SetValue(B_CONTROL_OFF);
   viewStretched->SetValue(B_CONTROL_OFF);
 }
 if (a==VIEW_MODE_WINDOW) {
   viewNormal->SetValue(B_CONTROL_OFF);
   viewTiled->SetValue(B_CONTROL_OFF);
   viewWindow->SetValue(B_CONTROL_ON);
   viewStretched->SetValue(B_CONTROL_OFF);
 }
 if (a==VIEW_MODE_STRETCH) {
   viewNormal->SetValue(B_CONTROL_OFF);
   viewTiled->SetValue(B_CONTROL_OFF);
   viewWindow->SetValue(B_CONTROL_OFF);
   viewStretched->SetValue(B_CONTROL_ON);
 }

 if (a==VIEW_MODE_FULL_SCREEN) viewFullScreen->SetValue(B_CONTROL_ON);
 if (a==VIEW_MODE_FILE_LIST) viewFileList->SetValue(B_CONTROL_ON);
}

// VIEWER WINDOW OPTIONS
