// constants.h
//
//
//  This file contains all the constants used by the program, such
//  as version info, messaging int32's... etc.
//


#ifndef _CONSTANTS_H
#define _CONSTANTS_H

#define PeekVersion "Peek 0.4"

// Internal messaging constants
#define PEEK_FILE_SAVE	 	'SAVE'
#define PEEK_SAVE_FILE		'SAFI'
#define PEEK_FILE_DELETE 	'DELE'
#define PEEK_LOAD		 	'LOAD'
#define PEEK_QUIT		 	'QUIT'
#define PEEK_INVOKE		 	'INVK'
#define PEEK_FULL_SCREEN 	'FULL'
#define PEEK_LIST_UP		'LSUP'
#define PEEK_OPTIONS_WINDOW	'POPT'
#define PEEK_OPTIONS_CLOSE	'POPC'
#define PEEK_FILES_HIDE		'PFHI'

// clipboard options
#define PEEK_CLIPBOARD_COPY	 'PCBC'
#define PEEK_CLIPBOARD_PASTE 'PCBP'


// desktop settings
#define PEEK_DESKTOP_TILED		'PDTI'
#define PEEK_DESKTOP_CENTERED	'PDCE'
#define PEEK_DESKTOP_MANUAL		'PDMA'
#define PEEK_DESKTOP_SCALED		'PDSC'
#define PEEK_DESKTOP_LOAD		'PDLO'
  // all info
#define PEEK_ALL_DESKTOP_TILED		'PATI'
#define PEEK_ALL_DESKTOP_CENTERED	'PACE'
#define PEEK_ALL_DESKTOP_MANUAL		'PAMA'
#define PEEK_ALL_DESKTOP_SCALED		'PASC'
#define PEEK_ALL_DESKTOP_LOAD		'PALO'



// screen capture constants
#define PEEK_CAPTURE_PEEK		'PCPE'
#define PEEK_CAPTURE_NO_PEEK	'PCNP'

// Image viewing constants
#define PEEK_IMAGE_TILED 	'TILE'
#define PEEK_IMAGE_NORMAL 	'NORM'
#define PEEK_IMAGE_RESIZE 	'RESZ'
#define PEEK_IMAGE_STRETCH 	'REST'

// Slideshow constants
#define PEEK_SLIDE_RANDOM 	'SRND'
#define PEEK_SLIDE_ASCEND 	'SASC'
#define PEEK_SLIDE_DESCEND 	'SDES'
#define PEEK_SLIDE_TOGGLE 	'STOG'
#define PEEK_SLIDE_CHANGE	'SCHG'

// Help constants
#define PEEK_HELP_HELP  	'HHEL'

// slideshow constants
#define P_DESCEND 	0
#define P_ASCEND 	1
#define P_RANDOM 	2

// window viewing modes
#define P_WINDOW 3
#define P_STRETCHED 2
#define P_TILED 1
#define P_NORMAL 0

// mouse button constants
#define P_CLIPPING 		'CLIP'
#define P_DRAGGING 		'DRAG'
#define P_SCROLLING 	'SCRO'
#define P_MENU 			'MENU'

// just for the dragging
#define P_ICON			'PDIC'

#endif